
#include <fstream.h>
#include <stdio.h>
#include <string.h>

#include <qapplication.h>

#include "computerspieler.hh"
#include "communicator.hh"
#include "main_win.hh"

int main(int argc, char **argv) {
  
  if (argc<5) { cerr<<"usage: battle c/m 1/2 kon/koff level\n"; exit(1); }
  
  strcpy(levelName,argv[4]);
  
  QApplication		a(argc,argv);
  computerspieler	*cs;
  communicator		*co;
  main_win		*mw;
  
  if (strcmp(argv[1],"c")==0) cs=new computerspieler();
  else if (strcmp(argv[1],"m")==0) cs=NULL;
  else { cerr<<"usage: battle c/m 1/2 kon/koff level\n"; exit(1); }
  
  if (strcmp(argv[2],"1")==0) mw=new main_win(1,cs);
  else if (strcmp(argv[2],"2")==0) mw=new main_win(2,cs);
  else { cerr<<"usage: battle c/m 1/2 kon/koff level\n"; exit(1); }
  
  if (strcmp(argv[3],"kon")==0) mw->kampf.status(1);
  else if (strcmp(argv[3],"koff")==0) mw->kampf.status(2);
  else { cerr<<"usage: battle c/m 1/2 kon/koff level\n"; exit(1); }
  
  co=new communicator(mw);
  mw->show();
  
  a.setMainWidget(mw);
  return a.exec();
  
}

