
#ifndef bildspeicher_header
#define bildspeicher_header

#include <qpixmap.h>

class land;
class main_win;

class bildspeicher {
  
  public:
  
  bildspeicher(main_win *m);
  ~bildspeicher();
  
  land *newLand(int type, int px, int py);
  
  QPixmap *get_land_pxm(int type);
  QPixmap *get_rahmen();
  QPixmap *get_moved();
  QPixmap *get_stellplatz();
  
  QPixmap *get_hq_pxm(int spieler);
  QPixmap *get_fa_pxm(int spieler);
  QPixmap *get_de_pxm(int spieler);
  
  QPixmap *getFahrzeug(int typ, int spieler);
  int getFahrzeugPreis(int typ);
  
  QPixmap *getStrasse(int str);
  
  char *getEinheitBeschreibung(int type);
  
  int getFahrzeugAnzahl();
  
  private:
  
  QPixmap	**land_pxm,
		**fahrzeuge_spieler1,
		**fahrzeuge_spieler2,
		**strasse,
		*rahmen,
		*moved,
		*stellplatz;
  double	*befahrbarkeit;
  int		*land_type,
  		*land_spieler,
  		*preis,
  		land_anzahl,
  		strasse_anzahl,
  		fahrzeug_anzahl;
  main_win	*mw;
  char		**einheit_beschreibung;
  
  void readLandBeschreibung();
  void readStrassenBeschreibung();
  void readEinheitenBeschreibung();
  void readFahrzeugePics();
  
};

#endif
