
#include <fstream.h>
#include <qpushbutton.h>

#include "depot.hh"
#include "depot_window.hh"

depot::depot(QWidget *parent, QPixmap *ans, double bef, int spieler, int px, int py, int fabrik, int hauptquartier)
  : QObject(), land(parent,ans,bef,FALSE) {
  
  int		i;
  
  factory=fabrik;
  headquarter=hauptquartier;
  
  my_posx=px;
  my_posy=py;
  
  if (factory) energie=30;
  else energie=20;
  
  akt_stellplatz=0;
  mw = (main_win *) (parent->topLevelWidget());
  gehoere_zu_spieler=spieler;
  
  for (i=0; i<anz_inhalt; i++) {
    inhalt[i]=NULL;
    bewegt[i]=FALSE;
  }
  
  inhalt_fenster=NULL;
  
}

depot::~depot() {
  
  int	i;
  
  if (inhalt_fenster!=NULL) delete inhalt_fenster;
  
  for (i=0; i<anz_inhalt; i++)
    if (inhalt[i]!=NULL) delete inhalt[i];
  
}

void depot::draw_ansicht(QPainter *pa, int posx, int posy) {
  
  pa->drawPixmap(posx,posy,*land::landbild);
  
  if (rahmen_v==TRUE) pa->drawPixmap(posx,posy,*land::rahmen_pixmap);
  
}

int depot::oeffnen() {
  
  if (inhalt_fenster==NULL) inhalt_fenster=new depot_window(mw,this);
  
  inhalt_fenster->show();
  inhalt_fenster->raise();
  inhalt_fenster->repaint();
  
  return TRUE;
  
}

void depot::schliessen() {
  
  if (inhalt_fenster!=NULL) inhalt_fenster->hide();
  
}

int depot::einheit_kommt_an(einheit *e, int platz) {
  
  if ((e->fusstruppe()==FALSE) && (e->gehoere_zu!=gehoere_zu())) return FALSE;
  
  if (platz!=-1) {
    if ((platz<0) || (platz>=anz_inhalt)) { cerr<<"falscher Stellplatz\n"; exit(1); }
    if (inhalt[platz]!=NULL) { cerr<<"Spieler "<<mw->bin_spieler<<" Platz "<<platz<<" im Depot ist schon besetzt\n"; exit(1); }
    akt_stellplatz=platz;
  } else {
    akt_stellplatz=0;
    while ((akt_stellplatz<anz_inhalt) && (inhalt[akt_stellplatz]!=NULL)) akt_stellplatz++;
    if (akt_stellplatz>=anz_inhalt) { cerr<<"Depot ist voll\n"; exit(1); }
  }
  
  inhalt[akt_stellplatz]=e;
  bewegt[akt_stellplatz]=TRUE;
  
  if (inhalt_fenster!=NULL) inhalt_fenster->redraw_inhalt();
  
  return TRUE;
  
}

void depot::modus_wechseln() {
  
  int		i;
  
  land::modus_wechseln();
  
  for (i=0; i<anz_inhalt; i++) bewegt[i]=FALSE;
  
  if (inhalt_fenster!=NULL) inhalt_fenster->redraw_inhalt();
  
}

einheit *depot::get_einheit(int number) {
  
  if (number!=-1) akt_stellplatz=number;
  
  if ((akt_stellplatz>=0) && (akt_stellplatz<anz_inhalt))
    return inhalt[akt_stellplatz];
  else { cerr<<"depot::get_einheit() interner Fehler\n"; exit(1); }
  
}

einheit *depot::einheit_geht(int number) {
  
  einheit	*e;
  
  if (number!=-1) akt_stellplatz=number;
  
  e=inhalt[akt_stellplatz];
  inhalt[akt_stellplatz]=NULL;
  
  if (inhalt_fenster!=NULL) inhalt_fenster->redraw_inhalt();
  
  return e;
  
}

void depot::einheit_zerstoert(int number) {
  
  if (number!=-1) akt_stellplatz=number;
  
  if (inhalt[akt_stellplatz]==NULL) return;
  
  if (inhalt[akt_stellplatz]->gehoere_zu==1) mw->anz_spieler1--;
  else mw->anz_spieler2--;
  
  delete inhalt[akt_stellplatz];
  inhalt[akt_stellplatz]=NULL;
  
}

int depot::get_akt_stellplatz() {
  return akt_stellplatz;
}

void depot::set_akt_stellplatz(int platz) {
  if ((platz>=0) && (platz<anz_inhalt)) akt_stellplatz=platz;
  else cerr<<"Warnung: platz zu gross oder zu klein!\n";
}

int depot::bin_depot() {
  return TRUE;
}

int depot::platz_frei() {
  
  int		i;
  
  for (i=0; i<anz_inhalt; i++)
    if (inhalt[i]==NULL) return TRUE;
  
  return FALSE;
  
}

int depot::gehoere_zu() {
  return gehoere_zu_spieler;
}

void depot::repariere_einheit(int platz) {
  
  if (inhalt[platz]!=NULL) {
    if ((energie>=3) && (inhalt[platz]->anzahl<10)) {
      inhalt[platz]->anzahl=10;
      inhalt[platz]->anzahl_d=10;
      bewegt[platz]=TRUE;
      energie-=3;
      if (inhalt_fenster!=NULL) inhalt_fenster->repaint();
    }
  } else cerr<<"Warnung: Reparatur von leerem Stellplatz!\n"; 
  
}

int depot::wieviel_energie() {
  return energie;
}

void depot::copy(depot *d) {
  energie=d->energie;
  if (inhalt_fenster!=NULL) inhalt_fenster->redraw_inhalt();
}

int depot::bin_factory() {
  return factory;
}

int depot::energieVerbrauch(int m) {
  
  if (m>energie) return FALSE;
  else {
    energie-=m;
    return TRUE;
  }
  if (inhalt_fenster!=NULL) inhalt_fenster->redraw_inhalt();
  
}

void depot::uebernahmeDurchSpieler(int spieler) {
  
  int		i;
  
  if (spieler!=gehoere_zu()) {
    gehoere_zu_spieler=spieler;
    for (i=0; i<anz_inhalt; i++) if (inhalt[i]!=NULL) inhalt[i]->uebernahmeDurchSpieler(spieler);
    if (headquarter) {
      if (spieler==1) mw->victory("player 2 lost his HQ, victory player 1\n");
      else mw->victory("player 1 lost his HQ, victory player 2\n");
    }
    if (headquarter) land::landbild=mw->bs.get_hq_pxm(spieler);
    else if (factory) land::landbild=mw->bs.get_fa_pxm(spieler);
    else land::landbild=mw->bs.get_de_pxm(spieler);
  }
  mw->zaehleFahrzeuge();
  
}

int depot::bin_headquarter() {
  return headquarter;
}

int depot::bin_depotumr() {
  return FALSE;
}

void depot::setEnergy(int e) {
  energie=e;
  if (inhalt_fenster!=NULL) inhalt_fenster->redraw_inhalt();
}
