
#ifndef depot_header
#define depot_header

#include <qobject.h>
#include <qwidget.h>

#include "main_win.hh"
#include "land.hh"

#define anz_inhalt	8

class einheit;

class depot : public QObject, public land {
  
  friend class depot_window;
  
  Q_OBJECT
  
  public:
  
  depot(QWidget *parent, QPixmap *ans, double bef, int spieler, int px, int py, int fabrik, int hauptquartier);
  virtual ~depot();
  
  virtual int platz_frei();
  
  virtual int einheit_kommt_an(einheit *e, int platz=-1);
  virtual einheit *einheit_geht(int platz=-1);
  virtual einheit *get_einheit(int platz=-1);
  virtual void einheit_zerstoert(int platz=-1);
  virtual int get_akt_stellplatz();
  virtual void set_akt_stellplatz(int platz);
  
  virtual void repariere_einheit(int platz);
  virtual int wieviel_energie();
  virtual int oeffnen();
  
  virtual void modus_wechseln();
  
  virtual void draw_ansicht(QPainter *pa, int posx, int posy);
  
  virtual int bin_depot();
  virtual int bin_factory();
  virtual int bin_headquarter();
  virtual int bin_depotumr();
  
  virtual int gehoere_zu();
  
  // kopiert nur Werte des Depots !!! (keine Einheiten)
  virtual void copy(depot *d);
  
  virtual void setEnergy(int e);
  
  int energieVerbrauch(int m);
  
  virtual void uebernahmeDurchSpieler(int spieler);
  
  public slots:
  
  void schliessen();
  
  private:
  
  main_win	*mw;
  depot_window	*inhalt_fenster;
  einheit	*inhalt[anz_inhalt];
  int		bewegt[anz_inhalt],
		my_posx, my_posy,
		akt_stellplatz,
		energie,
  		gehoere_zu_spieler,
		factory, headquarter;
  
};

#endif
