
#include <fstream.h>
#include <qpainter.h>
#include <stdio.h>

#include "main_win.hh"
#include "landschaft.hh"
#include "bildspeicher.hh"
#include "depot_window.hh"
#include "depot.hh"
#include "factory.hh"

depot_window::depot_window(main_win *parent, depot *parent_dep) :
  QWidget(),
  schliessen("close",this),
  energie("test",this),
  headline("test",this),
  beschr1("number/training",this),
  beschr2("number/training",this)
  {
  
  mw=parent;
  stellpl=mw->bs.get_stellplatz();
  moved=mw->bs.get_moved();
  
  fac=NULL;
  
  dep=parent_dep;
  
  schliessen.setGeometry(310,10,150,25);
  
  energie.setGeometry(220,10,80,25);
  energie.setFrameStyle(QFrame::Panel | QFrame::Raised);
  energie.setAlignment(AlignHCenter | AlignVCenter);
  
  headline.setGeometry(10,10,200,25);
  headline.setFrameStyle(QFrame::Panel | QFrame::Raised);
  headline.setAlignment(AlignHCenter | AlignVCenter);
  
  beschr1.setGeometry(80,45,150,25);
  beschr1.setFrameStyle(QFrame::Panel | QFrame::Raised);
  beschr1.setAlignment(AlignHCenter | AlignVCenter);
  
  beschr2.setGeometry(310,45,150,25);
  beschr2.setFrameStyle(QFrame::Panel | QFrame::Raised);
  beschr2.setAlignment(AlignHCenter | AlignVCenter);
  
  connect(&schliessen,SIGNAL(clicked()),dep,SLOT(schliessen()));
  
  resize(470,345);
  
  fac=new factory(parent,parent_dep);
  
  paintEvent(NULL);
  
}

depot_window::~depot_window() {
  
  if (fac!=NULL) delete fac;
  
}

void depot_window::paintEvent(QPaintEvent *) {
  
  QPainter	pa;
  int		i, x, y;
  char		str[128];
  
  pa.begin(this);
  x=10;
  y=80;
  for (i=0; i<anz_inhalt; i++) {
    pa.drawPixmap(x,y,*stellpl);
    if (dep->inhalt[i]!=NULL) {
      sprintf(str,"%d/%d",dep->inhalt[i]->anzahl,dep->inhalt[i]->ausbildung);
      pa.drawText(x+70,y+10,str);
      pa.drawPixmap(x,y,*(dep->inhalt[i]->ansicht));
      if (dep->bewegt[i]==TRUE)
        pa.drawPixmap(x,y,*moved);
    }
    y+=65;
    if ((i+1)%4==0) { x+=230; y=80; }
  }
  pa.end();
  
  sprintf(str,"energy %d",dep->energie);
  energie.setText(str);
  
  if (dep->factory) strcpy(str,"factory player ");
  else if (dep->headquarter) strcpy(str,"HQ player ");
  else strcpy(str,"depot player ");
  
  if (dep->gehoere_zu()==1) strcat(str,"1 red ");
  else strcat(str,"2 blue ");
  if (mw->bin_spieler==dep->gehoere_zu()) {
    if (mw->aktueller_modus()==bewegungsmodus) strcat(str,"move");
    else strcat(str,"repaire");
  }
  headline.setText(str);
  
}

void depot_window::closeEvent(QCloseEvent *ev) {
  QWidget::closeEvent(ev);
  dep->schliessen();
}

void depot_window::redraw_inhalt() {
  paintEvent(NULL);
}

void depot_window::mouseReleaseEvent(QMouseEvent *me) {
  
  landschaft	*ls;
  
  if ((me->x()>=10) && (me->y()>=80)) {
    
    dep->akt_stellplatz=(me->y()-80)/65+(me->x()-10)/230*4;
    if (dep->akt_stellplatz<0) dep->akt_stellplatz=0;
    if (dep->akt_stellplatz>=anz_inhalt) dep->akt_stellplatz=anz_inhalt-1;
    
    if ((dep->inhalt[dep->akt_stellplatz]!=NULL) && (dep->bewegt[dep->akt_stellplatz]==FALSE)) {
      if (mw->aktueller_modus()==bewegungsmodus) {
        // Bewegen
        ls=mw->get_landschaft();
        mw->raise();
        mw->repaint();
        ls->steuerung_bewegungsmodus(dep->my_posx,dep->my_posy);
        paintEvent(NULL);
      } else {
        // Reparatur
        dep->repariere_einheit(dep->akt_stellplatz);
      }
    }
    
    if ((dep->inhalt[dep->akt_stellplatz]==NULL) && (dep->bin_factory()) &&
      (mw->aktueller_modus()==angriffsmodus)) baueFahrzeug();
    
  }
  
}

void depot_window::baueFahrzeug() {
  
  if ((dep->platz_frei()) && (mw->aktueller_modus()==angriffsmodus) && (mw->bin_spieler==dep->gehoere_zu()))
    fac->show();
  
}

