
#include <fstream.h>
#include <qbitmap.h>
#include <stdio.h>

#include "einheit.hh"
#include "main_win.hh"

int		einheit_id_count=0;

einheit::einheit(QWidget *parent, int type, int spieler) {
  
  einheit_id=einheit_id_count++;
  
  mw = (main_win *) (parent->topLevelWidget());
  
  fahrzeug_anzahl=mw->bs.getFahrzeugAnzahl();
  
  StrategieDaten=new int [fahrzeug_anzahl];
  
  parent_widget=parent;
  was_bin_ich=type;
  gehoere_zu=spieler;
  
  read(mw->bs.getEinheitBeschreibung(type));
  
  ansicht=mw->bs.getFahrzeug(type,gehoere_zu);
  
  if (gehoere_zu==1) {
    mw->anz_spieler1++;
    pxm_name=pxm_sp1_name;
  } else {
    mw->anz_spieler2++;
    pxm_name=pxm_sp2_name;
  }
  
}

einheit::~einheit() {
  if (StrategieDaten!=0) delete StrategieDaten;
}

void einheit::read(char *filename) {
  
  ifstream	eingabe(filename);
  char		line[256];
  int		i;
  
  if (!eingabe) { cerr<<"Eingabedatei "<<filename<<" konnte nicht geoeffnet werden!\n"; exit(1); }
  
  eingabe>>line;
  if (strcmp(line,"Gruppe:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  gruppe[0]=0;
  eingabe>>line;
  strncpy(gruppe,line,NAME_LEN);
  
  eingabe>>line;
  if (strcmp(line,"Anzahl:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  eingabe>>line;
  sscanf(line,"%d",&anzahl);
  anzahl_d=(double)anzahl;
  
  eingabe>>line;
  if (strcmp(line,"Ausbildung:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  eingabe>>line;
  sscanf(line,"%d",&ausbildung);
  
  eingabe>>line;
  if (strcmp(line,"MinSchussweite:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  eingabe>>line;
  sscanf(line,"%d",&min_schussweite);
  
  eingabe>>line;
  if (strcmp(line,"MaxSchussweite:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  eingabe>>line;
  sscanf(line,"%d",&max_schussweite);
  
  eingabe>>line;
  if (strcmp(line,"Bewegung:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  eingabe>>line;
  sscanf(line,"%d",&bewegung);
  
  eingabe>>line;
  if (strcmp(line,"Panzerung:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  eingabe>>line;
  sscanf(line,"%d",&panzerung);
  
  eingabe>>line;
  if (strcmp(line,"FeuerkraftLuft:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  eingabe>>line;
  sscanf(line,"%d",&feuerkraft_luft);
  
  eingabe>>line;
  if (strcmp(line,"FeuerkraftBoden:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  eingabe>>line;
  sscanf(line,"%d",&feuerkraft_boden);
  
  eingabe>>line;
  if (strcmp(line,"Flugzeug:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  eingabe>>line;
  if (strncasecmp(line,"FALSE",5)==0) flugzeug=FALSE;
  else if (strncasecmp(line,"TRUE",4)==0) flugzeug=TRUE;
  else { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  
  eingabe>>line;
  if (strcmp(line,"Fusstruppe:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  eingabe>>line;
  if (strncasecmp(line,"FALSE",5)==0) fusstr=FALSE;
  else if (strncasecmp(line,"TRUE",4)==0) fusstr=TRUE;
  else { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  
  eingabe>>line;
  if (strcmp(line,"Bild_Spieler1:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  eingabe>>line;
  strncpy(pxm_sp1_name,line,NAME_LEN);
  
  eingabe>>line;
  if (strcmp(line,"Bild_Spieler2:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  eingabe>>line;
  strncpy(pxm_sp2_name,line,NAME_LEN);
  
  eingabe>>line;
  if (strcmp(line,"MissleName:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  eingabe>>line;
  strncpy(missle,line,NAME_LEN);
  
  eingabe>>line;
  if (strcmp(line,"StrategieDaten:")!=0) { cerr<<"Falsches Dateiformat: "<<filename<<endl; exit(1); }
  for (i=0; i<fahrzeug_anzahl; i++) {
    if (eingabe.eof()) { cerr<<"cant read all StrategieDaten in "<<filename<<endl; exit(1); }
    eingabe>>StrategieDaten[i];
  }
  
}

void einheit::copy(einheit *e) {
  
  if ( (was_bin_ich!=e->was_bin_ich) || (gehoere_zu!=e->gehoere_zu) ) {
    cerr<<"Einheiten sind verschieden!\n";
    exit(1);
  }
  
  einheit_id=e->einheit_id;
  
  anzahl_d=e->anzahl_d;
  anzahl=e->anzahl;
  ausbildung=e->ausbildung;
  
}

int einheit::get_einheit_id() {
  return einheit_id;
}

void einheit::print() {
  
  cout<<"Einheit-ID: "<<einheit_id<<endl;
  cout<<"Typ: "<<was_bin_ich<<endl;
  cout<<"Spieler: "<<gehoere_zu<<endl;
  cout<<"Anzahl: "<<anzahl<<endl;
  cout<<"Ausbildung: "<<ausbildung<<endl;
  cout<<"Min Schussweite: "<<min_schussweite<<endl;
  cout<<"Max Schussweite: "<<max_schussweite<<endl;
  cout<<"Bewegung: "<<bewegung<<endl;
  cout<<"Panzerung: "<<panzerung<<endl;
  cout<<"Feuerkraft Luft: "<<feuerkraft_luft<<endl;
  cout<<"Feuerkraft Boden: "<<feuerkraft_boden<<endl;
  
}

void einheit::uebernahmeDurchSpieler(int spieler) {
  gehoere_zu=spieler;
  ansicht=mw->bs.getFahrzeug(was_bin_ich,spieler);
  if (spieler==1) pxm_name=pxm_sp1_name;
  else pxm_name=pxm_sp2_name;
}

int einheit::fusstruppe() {
  return fusstr;
}

char *einheit::getMissleName() {
  return missle;
}

void einheit::werte2data(einheitData & data) {
  data.anzahl_d=anzahl_d;
  data.anzahl=anzahl;
  data.ausbildung=ausbildung;
  data.gehoere_zu=gehoere_zu;
  data.id=einheit_id;
  data.type=was_bin_ich;
}

void einheit::data2werte(einheitData & data) {
  if (data.id!=einheit_id) {
    if (data.type!=was_bin_ich) {
      cerr<<"Fehler: copy nur bei gleichen Einheiten!\n";
      print();
      exit(1);
    } else {
      // das kann eine Fehlerquelle sein!
      einheit_id=data.id;
    }
  }
  anzahl_d=data.anzahl_d;
  anzahl=data.anzahl;
  ausbildung=data.ausbildung;
  gehoere_zu=data.gehoere_zu;
}

