
#include <stdio.h>
#include <fstream.h>

#include "factory.hh"

#define spaltenbreite		100
#define zeilenhoehe		70
#define anz_zeilen		4

factory::factory(main_win *mainw, depot *d) {
  
  mw=mainw;
  dep=d;
  
  fahrzeug_anzahl=mw->bs.getFahrzeugAnzahl();
  
  hide();
  
}

factory::~factory() {
}

void factory::paintEvent(QPaintEvent *) {
  
  int		s, z, sp, ze, p;
  QPainter	pa;
  char		str[64];
  
  ze=anz_zeilen;
  sp=fahrzeug_anzahl/ze+1;
  
  resize(sp*spaltenbreite,ze*zeilenhoehe);
  
  pa.begin(this);
  for (z=0; z<ze; z++) {
    for (s=0; s<sp; s++) {
      p=s*ze+z;
      if (p<fahrzeug_anzahl) {
        pa.drawPixmap(s*spaltenbreite,z*zeilenhoehe,*(mw->bs.getFahrzeug(p,mw->bin_spieler)));
        sprintf(str,"%d",mw->bs.getFahrzeugPreis(p));
        pa.drawText(s*spaltenbreite+zeilenhoehe,z*zeilenhoehe+zeilenhoehe/2,str);
      }
    }
  }
  pa.end();
  
}

void factory::mouseReleaseEvent(QMouseEvent *mo) {
  
  int		p;
  
  hide();
  
  p=mo->x()/spaltenbreite*anz_zeilen+mo->y()/zeilenhoehe;
  
  if (p<fahrzeug_anzahl) {
    if (dep->energieVerbrauch(mw->bs.getFahrzeugPreis(p))) {
      if (dep->einheit_kommt_an(new einheit(mw,p,mw->bin_spieler))==FALSE) {
        cerr<<"cant build einheit\n";
        exit(1);
      }
    }
  }
  mw->zaehleFahrzeuge();
  
}

