
#include <sys/msg.h>

#include <qpainter.h>
#include <unistd.h>
#include <fstream.h>
#include <stdio.h>

#include "kampfhandlung.hh"
#include "communicator.hh"
#include "menu.hh"

kampfhandlung::kampfhandlung(int spieler) :
  gegner_pixmap(),
  hintergrund("pics/background.jpg"),
  missle_gegner(),
  missle_angreifer(),
  buffer("pics/background.jpg")
  {
  
  int		i;
  char		name[128];
  MenuMsg	msg;
  
  sp=spieler;
  kampfbildschirm=TRUE;
  
  setFixedSize(350,350);
  
  for (i=0; i<10; i++) expl_anim[i]=NULL;
  
  for (i=0; i<10; i++) {
    sprintf(name,"anim/explosion_%d.ppm",i);
    expl_anim[i]=new QPixmap(name);
    expl_anim[i]->setMask(expl_anim[i]->createHeuristicMask());
  }
  
  ipc_key=ftok(".",'B');
  if (ipc_key==-1) { perror("cant create ipc-key"); exit(1); }
  
  msq_id=msgget(ipc_key,IPC_CREAT|0660);
  if (msq_id==-1) { perror("cant create msg-queue"); exit(1); }
  
  msg.mtype=MSGTYPE_PID;
  msg.pid=getpid();
  if (msgsnd(msq_id,(struct msgbuf *)(&msg),sizeof(MenuMsg)-sizeof(long),0)==-1) { perror("cant send message, deadlock: start_game waites for answer"); exit(1); }
  
  mode=0;
  
  hide();
  
  startTimer(100);
  
}

kampfhandlung::~kampfhandlung() {
  
  int		i;
  
  for (i=0; i<10; i++)
    if (expl_anim[i]!=NULL) delete expl_anim[i];
  
}

void kampfhandlung::kampf_start(KampfMsg & msg) {
  
  QPainter	pa;
  
  show();
  
  mode=1;
  count1=0;
  count2=0;
  
  gegenw=msg.gegenwehr;
  
  anz_angreifer_o=msg.ang_old_anz;
  anz_angreifer_n=msg.ang_anz;
  anz_gegner_o=msg.geg_old_anz;
  anz_gegner_n=msg.geg_anz;
  
  ypos_angreifer=350;
  ypos_gegner=-60;
  ypos_missle_angreifer=200;
  ypos_missle_gegner=90;
  
  if (gegner_pixmap.load(msg.geg_pxm_name)==FALSE) {
    cerr<<"kann "<<msg.geg_pxm_name<<" nicht oeffnen\n";
    exit(1);
  }
  angreifer_pixmap.load(msg.geg_pxm_name);
  angreifer_pixmap.setMask(angreifer_pixmap.createHeuristicMask());
  pa.begin(&gegner_pixmap);
  pa.eraseRect(0,0,gegner_pixmap.width(),gegner_pixmap.height());
  pa.translate(30.0,30.0); 
  pa.rotate(180.0);   
  pa.drawPixmap(-30,-30,angreifer_pixmap);
  pa.end();
  if (angreifer_pixmap.load(msg.ang_pxm_name)==FALSE) {
    cerr<<"kann "<<msg.ang_pxm_name<<" nicht oeffnen\n";
    exit(1);
  }
  angreifer_pixmap.setMask(angreifer_pixmap.createHeuristicMask());
  gegner_pixmap.setMask(gegner_pixmap.createHeuristicMask());
  
  if (missle_gegner.load(msg.geg_msl_name)==FALSE) {
    cerr<<"kann "<<msg.geg_msl_name<<" nicht oeffnen\n";
    exit(1);
  }
  missle_angreifer.load(msg.geg_msl_name);
  missle_angreifer.setMask(missle_angreifer.createHeuristicMask());
  pa.begin(&missle_gegner);
  pa.eraseRect(0,0,missle_gegner.width(),missle_gegner.height());
  pa.translate(30.0,30.0); 
  pa.rotate(180.0);   
  pa.drawPixmap(-30,-30,missle_angreifer);
  pa.end();
  if (missle_angreifer.load(msg.ang_msl_name)==FALSE) {
    cerr<<"kann "<<msg.ang_msl_name<<" nicht oeffnen\n";
    exit(1);
  }
  missle_angreifer.setMask(missle_angreifer.createHeuristicMask());
  missle_gegner.setMask(missle_gegner.createHeuristicMask());
  
}

void kampfhandlung::kampf_ende() {
  
  KampfMsg	msg;
  
  msg.mtype=BEFEHL_KAMPF_FERTIG+sp;
  if (msgsnd(msq_id,(msgbuf *)(&msg),sizeof(KampfMsg)-sizeof(long),0)==-1) { perror("cant send message"); exit(1); }
  
  mode=0;
  
  hide();
  
}

void kampfhandlung::paintEvent(QPaintEvent *) {
  
  int		i;
  QPainter	pa;
  
  pa.begin(&buffer);
  switch(mode) {
    case 1:
      pa.drawPixmap(0,0,hintergrund);
      for (i=0; i<anz_gegner_o; i++)
        pa.drawPixmap(10+i*30,ypos_gegner-(i%2)*35,gegner_pixmap);
      for (i=0; i<anz_angreifer_o; i++)
        pa.drawPixmap(10+i*30,ypos_angreifer+(i%2)*35,angreifer_pixmap);
      break;
    case 2:
      pa.drawPixmap(0,0,hintergrund);
      for (i=0; i<anz_gegner_o; i++)
        pa.drawPixmap(10+i*30,ypos_gegner-(i%2)*35,gegner_pixmap);
      for (i=0; i<anz_angreifer_o; i++) {
        pa.drawPixmap(10+i*30,ypos_angreifer+(i%2)*35,angreifer_pixmap);
        pa.drawPixmap(10+i*30,ypos_missle_angreifer+(i%2)*35,missle_angreifer);
      }
      for (i=0; i<anz_gegner_o; i++)
        if (gegenw) pa.drawPixmap(10+i*30,ypos_missle_gegner-(i%2)*35,missle_gegner);
      break;
    case 3:
      pa.drawPixmap(0,0,hintergrund);
      for (i=0; i<anz_gegner_n; i++)
        pa.drawPixmap(10+i*30,ypos_gegner-(i%2)*35,gegner_pixmap);
      for (i=anz_gegner_n; i<anz_gegner_o; i++)
        pa.drawPixmap(10+i*30,ypos_gegner-(i%2)*35,*(expl_anim[count2]));
      for (i=0; i<anz_angreifer_n; i++)
        pa.drawPixmap(10+i*30,ypos_angreifer+(i%2)*35,angreifer_pixmap);
      for (i=anz_angreifer_n; i<anz_angreifer_o; i++)
        pa.drawPixmap(10+i*30,ypos_angreifer+(i%2)*35,*(expl_anim[count2]));
      break;
  }
  pa.end();
  
  pa.begin(this);
  pa.drawPixmap(0,0,buffer);
  pa.end();
  
}

void kampfhandlung::timerEvent(QTimerEvent *) {
  
  KampfMsg	msg;
  
  switch(mode) {
    case 0:
      if (msgrcv(msq_id,(msgbuf *)(&msg),sizeof(KampfMsg)-sizeof(long),BEFEHL_KAMPF_START+sp,0)==-1) { perror("cant recieve message"); exit(1); }
      readKampfbildschirm();
      if (kampfbildschirm) kampf_start(msg);
      else mode=4;
      break;
    case 1:
      if ((ypos_gegner+=5)>60) mode++;
      ypos_angreifer-=5;
      break;
    case 2:
      if ((count1++)>30) mode++;
      ypos_missle_gegner+=5;
      ypos_missle_angreifer-=5;
      break;
    case 3:
      if ((count2++)>=9) mode++;
      break;
    case 4:
      kampf_ende();
      break;
    default:
      cerr<<"unknown mode\n";
      exit(1);
  } 
  paintEvent(NULL);
  
}

void kampfhandlung::readKampfbildschirm() {
  
  KampfMsg	msg;
  int		r;
  
  do {
    r=msgrcv(msq_id,(msgbuf *)(&msg),sizeof(KampfMsg)-sizeof(long),BEFEHL_KAMPFBILDSCHIRM+sp,IPC_NOWAIT);
    if (r!=-1) kampfbildschirm=msg.kampfbildschirm;
  } while (r!=-1);
  
}

