
#ifndef kampfhandlung_H
#define kampfhandlung_H

#include <sys/types.h>
#include <sys/ipc.h>

#include <qwidget.h>
#include <qpixmap.h>

#include "einheit.hh"

typedef struct {
  long		mtype;
  int		ang_old_anz,
  		ang_anz,
  		geg_old_anz,
  		geg_anz,
  		gegenwehr,
  		kampfbildschirm;
  char		ang_pxm_name[64],
  		geg_pxm_name[64],
  		ang_msl_name[64],
  		geg_msl_name[64];
} KampfMsg;

class kampfhandlung : public QWidget {
  
  public:
  
  kampfhandlung(int spieler);
  ~kampfhandlung();
  
  protected:
  
  void paintEvent(QPaintEvent *);
  void timerEvent(QTimerEvent *);
  
  private:
  
  int		mode, count1, count2, gegenw,
		anz_angreifer_o, anz_gegner_o,
		anz_angreifer_n, anz_gegner_n,
		ypos_angreifer, ypos_gegner,
		ypos_missle_angreifer, ypos_missle_gegner;
  QPixmap	gegner_pixmap, angreifer_pixmap,
		hintergrund, missle_gegner, missle_angreifer,
		*expl_anim[10],
		buffer;
  
  key_t		ipc_key;
  int		msq_id, sp, kampfbildschirm;
  
  void kampf_start(KampfMsg & msg);
  void kampf_ende();
  
  void readKampfbildschirm();
  
};

#endif
