
#include <fstream.h>
#include <qbitmap.h>

#include "land.hh"
#include "main_win.hh"
#include "landschaft.hh"

land::land(QWidget *parent, QPixmap *ans, double bef, int du) {
  
  mw = (main_win *) (parent->topLevelWidget());
  
  depot_umr=du;
  parent_widget=parent;
  eh=NULL;
  rahmen_v=FALSE;
  zug_beendet_v=FALSE;
  
  landbild=ans;
  befahrbarkeit=bef;
  
  moved_pixmap=mw->bs.get_moved();
  rahmen_pixmap=mw->bs.get_rahmen();
  
  strasse_pixmap=NULL;
  
}

land::~land() {
  
  if (eh!=NULL) delete eh;
  
}

int land::einheit_kommt_an(einheit *e, int) {
  
  if (e==NULL) { cerr<<"Einheit==NULL (zuwenig Speicher oder interner Fehler)\n", exit(1); }
  if (eh!=NULL) return FALSE;
  
  eh=e;
  zug_beendet(TRUE);
  
  return TRUE;
  
}

einheit * land::einheit_geht(int) {
  
  einheit	*e;
  
  e=eh;
  eh=NULL;
  
  return e;
  
}

einheit * land::get_einheit(int) {
  return eh;
}

void land::rahmen(int bo) {
  if (zug_beendet_v==TRUE) rahmen_v=FALSE;
  else rahmen_v=bo;
}

int land::rahmen() {
  return rahmen_v;
}

void land::zug_beendet(int bo) {
  zug_beendet_v=bo;
}

int land::zug_beendet() {
  return zug_beendet_v;
}

void land::einheit_zerstoert(int) {
  
  if (eh==NULL) return;
  
  if (eh->gehoere_zu==1) mw->anz_spieler1--;
  else mw->anz_spieler2--;
  
  delete eh;
  eh=NULL;
  
}

void land::modus_wechseln() {
  
  if (zug_beendet()==TRUE) zug_beendet(FALSE);
  if (rahmen()==TRUE) rahmen(FALSE);
  
}

void land::draw_ansicht(QPainter *pa, int posx, int posy) {
  
  pa->drawPixmap(posx,posy,*landbild);
  if (strasse_pixmap!=NULL) pa->drawPixmap(posx,posy,*strasse_pixmap);
  if (eh!=NULL) pa->drawPixmap(posx,posy,*(eh->ansicht));
  if (zug_beendet_v==TRUE) pa->drawPixmap(posx,posy,*moved_pixmap);
  else if (rahmen_v==TRUE) pa->drawPixmap(posx,posy,*rahmen_pixmap);
  
}

int land::oeffnen() {
  return FALSE;
}

int land::bin_depot() {
  return FALSE;
}

int land::platz_frei() {
  if (eh==NULL) return TRUE;
  else return FALSE;
}

int land::gehoere_zu() {
  return -1;
}

int land::get_akt_stellplatz() {
  return -1;
}

void land::set_akt_stellplatz(int) {
}


void land::repariere_einheit(int) {
}

int land::wieviel_energie() {
  return -1;
}

void land::copy(land *) {
}

int land::bin_factory() {
  return FALSE;
}

void land::uebernahmeDurchSpieler(int) {
  cerr<<"land kann nicht erobert werden\n";
  exit(1);
}

int land::bin_headquarter() {
  return FALSE;
}

void land::setStrasse(int strasse) {
  if (bin_depot() || bin_depotumr()) { cerr<<"error: depot should be a street\n"; exit(1); }
  strasse_pixmap=mw->bs.getStrasse(strasse);
  befahrbarkeit=1;
}

int land::bin_depotumr() {
  return depot_umr;
}

int land::bin_strasse() {
  if (strasse_pixmap!=NULL) return TRUE;
  else return FALSE;
}

void land::setEnergy(int) {
}
