
#ifndef landschaft_header
#define landschaft_header

#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include <qscrollbar.h>

#include "land.hh"

#define nachbar_ol	1
#define nachbar_ul	2
#define nachbar_o	3
#define nachbar_u	4
#define nachbar_or	5
#define nachbar_ur	6

class main_win;
class communicator;
class einheit;

class landschaft : public QWidget {
  
  friend class depot_window;
  
  Q_OBJECT
  
  public:
  
  landschaft(char *filename, QWidget *parent=0, const char *name=0);
  ~landschaft();
  
  QPixmap	*karte;
  
  void erzeugeKarte();
  
  void bewege_einheit(int sx, int sy, int ex, int ey);
  void greife_einheit_an(int sx, int sy, int ex, int ey, int gegenwehr);
  einheit *get_einheit(int x, int y, int platz=-1);
  void einheit_zerstoert(int x, int y, int platz=-1);
  
  void modus_wechseln();
  
  void neuer_communicator(communicator *com);
  
  void landschaft_groesse(int *w, int *h);
  
  land *get_land(int x, int y);
  
  einheit *nachbar(int x, int y, int wo);	// Nachbar in Richtung wo
  int nachbar_koords(int x, int y, int wo, int *kx, int *ky);
  
  // fuer interne Zwecke !!!
  void bewegung_ausfuehren(int sx, int sy, int ex, int ey, int platz_start, int platz_ziel);
  void steuerung_bewegungsmodus(int klickx, int klicky);
  void steuerung_angriffsmodus(int klickx, int klicky);
  void steuerung_reset();
  
  void zaehleFahrzeuge();
  
  public slots:
  
  void set_offx(int);
  void set_offy(int);
  void paint_new();
  
  protected:
  
  void paintEvent(QPaintEvent *);
  void mouseReleaseEvent(QMouseEvent *me);
  
  private:
  
  communicator	*co;
  main_win	*mw;
  QScrollBar	*updown, *leftright;
  QPainter	*paint;
  land		***la;
  int		landwidth, landheight,
		offx, offy,
		klick, first_klickx, first_klicky,
		anderer_spieler;
  
  int read(char *filename);
  
  int ist_in_radius(int r, int mx, int my, int x, int y);
  
  void markiere_erreichbare_felder(int sx, int sy, double bew, int flugzeug);
  void markiere_erreichbare_felder_rek(double *feld_bew, int *feld_erg, double *schritte, int sx, int sy, double bew, int flugzeug);
  
};

#endif

