
#ifndef main_win_header
#define main_win_header

#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qbitmap.h>

#include "landschaft.hh"
#include "einheit.hh"
#include "bildspeicher.hh"
#include "mytogglebutton.hh"
#include "kampfhandlung.hh"

#define bewegungsmodus	1
#define angriffsmodus	2

class communicator;
class computerspieler;

extern char levelName[256];

class main_win : public QWidget {
  
  Q_OBJECT
  
  public:
  
  MyToggleButton	kampf;
  bildspeicher		bs;
  int			anz_spieler1,
			anz_spieler2,
			bin_spieler;
  
  main_win(int spieler, computerspieler *csp=NULL, QWidget *parent=0, const char *name=0);
  ~main_win();
  
  void neuer_communicator(communicator *com);
  
  void modus_wechseln();
  int aktueller_modus();
  void info(einheit *e);
  landschaft *get_landschaft();
  
  int bin_computerspieler();
  
  void zaehleFahrzeuge();
  
  void redraw();
  
  void victory(char *txt);
  
  public slots:
  
  void modus_change_pressed();
  void exitProg();
  
  protected:
  
  void paintEvent(QPaintEvent *);
  void closeEvent(QCloseEvent *);
  void timerEvent(QTimerEvent *);
  
  private:
  
  communicator		*co;
  QPushButton		*ende, *mod_wechsel;
  QLabel		*modus_label,
			*status_label,
			*info_label,
			karte;
  landschaft		*ls;
  int			modus, can_change_mod;
  computerspieler	*cs;
  
  void set_modus(int new_modus);
  void show_status();
  
};


#endif


