#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <qpainter.h>
#include <qapplication.h>

#include "menu.hh"

int msq_id;

menu::menu() :
  st_bat("start",this),
  choose_lev("choose",this),
  quit_bt("quit",this),
  sp1(this,"human","computer"),
  sp2(this,"human","computer"),
  ka1(this,"battle screen on","battle screen off"),
  ka2(this,"battle screen on","battle screen off"),
  di1(this),
  di2(this),
  lev(this),
  title("pics/title.jpg"),
  lev_list()
  {

  setFixedSize(640,480);
  
  setBackgroundPixmap(title);

  sp1.setGeometry(20,320,140,20);
  sp2.setGeometry(180,320,140,20);
  ka1.setGeometry(20,350,140,20);
  ka2.setGeometry(180,350,140,20);
  lev.setGeometry(20,380,140,20);
  choose_lev.setGeometry(180,380,140,20);
  di1.setGeometry(20,410,140,20);
  di2.setGeometry(180,410,140,20);
  st_bat.setGeometry(20,440,140,20);
  quit_bt.setGeometry(180,440,140,20);

  connect(&quit_bt,SIGNAL(clicked()),qApp,SLOT(quit()));
  
  ka2.status(2);
  sp2.status(2);

  di1.setText(":0.0");
  di2.setText(":0.0");
  lev.setText("level1");
  
  connect(&st_bat,SIGNAL(clicked()),this,SLOT(start_battle()));
  ipc_key=ftok(".",'B');
  if (ipc_key==-1) { perror("cant create ipc-key"); exit(1); }
  
  msq_id=msgget(ipc_key,IPC_CREAT|0660);
  if (msq_id==-1) { perror("cant create msg-queue"); exit(1); }
  
  battle1=0;
  battle2=0;
  fight1=0;
  fight2=0;
  
  victory[0]=0;
  
  connect(&choose_lev,SIGNAL(clicked()),this,SLOT(showLevList()));
  connect(&lev_list,SIGNAL(selected(int)),this,SLOT(levSelected(int)));

  lev_list.resize(200,200);
  lev_list.setCaption("choose Level");
  lev_list.hide();
  
  readLevList();
  
  setCaption("XB.I.C. by Torsten Brischalle & Ingo Berg");
}

menu::~menu() {
  
  if (battle1!=0) kill(battle1,SIGKILL);
  if (battle2!=0) kill(battle2,SIGKILL);
  if (fight1!=0) kill(fight1,SIGKILL);
  if (fight2!=0) kill(fight2,SIGKILL);
  
}

void menu::start_battle() {
  
  char		name[256];
  MenuMsg	msg;
  
  hide();
  
  strcpy(name,"bin/fight 1 -display ");
  strcat(name,di1.text().data());
  strcat(name," &");
  if (system(name)!=0) { cerr<<"cant execute "<<name<<endl; exit(1); }
  if (msgrcv(msq_id,(struct msgbuf *)(&msg),sizeof(MenuMsg)-sizeof(long),MSGTYPE_PID,0)==-1) { perror("cant recieve message"); exit(1); }
  fight1=msg.pid;
  
  strcpy(name,"bin/fight 2 -display ");
  strcat(name,di2.text().data());
  strcat(name," &");
  if (system(name)!=0) { cerr<<"cant execute "<<name<<endl; exit(1); }
  if (msgrcv(msq_id,(struct msgbuf *)(&msg),sizeof(MenuMsg)-sizeof(long),MSGTYPE_PID,0)==-1) { perror("cant recieve message"); exit(1); }
  fight2=msg.pid;
  
  strcpy(name,"bin/battle");
  if (sp1.status()==1) strcat(name," m 1");
  else strcat(name," c 1");
  if (ka1.status()==1) strcat(name," kon ");
  else strcat(name," koff ");
  strcat(name,lev.text().data());
  strcat(name," -display ");
  strcat(name,di1.text().data());
  strcat(name," &");
  if (system(name)!=0) { cerr<<"cant execute "<<name<<endl; exit(1); }
  if (msgrcv(msq_id,(struct msgbuf *)(&msg),sizeof(MenuMsg)-sizeof(long),MSGTYPE_PID,0)==-1) { perror("cant recieve message"); exit(1); }
  battle1=msg.pid;
  
  strcpy(name,"bin/battle");
  if (sp2.status()==1) strcat(name," m 2");
  else strcat(name," c 2");
  if (ka2.status()==1) strcat(name," kon ");
  else strcat(name," koff ");
  strcat(name,lev.text().data());
  strcat(name," -display ");
  strcat(name,di2.text().data());
  strcat(name," &");
  if (system(name)!=0) { cerr<<"cant execute "<<name<<endl; exit(1); }
  if (msgrcv(msq_id,(struct msgbuf *)(&msg),sizeof(MenuMsg)-sizeof(long),MSGTYPE_PID,0)==-1) { perror("cant recieve message"); exit(1); }
  battle2=msg.pid;
  
  startTimer(500);
  
}

void menu::timerEvent(QTimerEvent *) {
  
  char		name[256];
  struct stat	buf;
  MenuMsg	msg;
  
  sprintf(name,"/proc/%d",fight1);
  if (stat(name,&buf)!=0) fight1=0;
  
  sprintf(name,"/proc/%d",fight2);
  if (stat(name,&buf)!=0) fight2=0;
  
  sprintf(name,"/proc/%d",battle1);
  if (stat(name,&buf)!=0) battle1=0;
  
  sprintf(name,"/proc/%d",battle2);
  if (stat(name,&buf)!=0) battle2=0;
  
  if ((fight1==0) || (fight2==0) || (battle1==0) || (battle2==0)) {
    if (battle1!=0) kill(battle1,SIGKILL);
    battle1=0;
    if (battle2!=0) kill(battle2,SIGKILL);
    battle2=0;
    if (fight1!=0) kill(fight1,SIGKILL);
    fight1=0;
    if (fight2!=0) kill(fight2,SIGKILL);
    fight2=0;
    
    msg.victory[0]=0;
    while (msgrcv(msq_id,(struct msgbuf *)(&msg),sizeof(MenuMsg)-sizeof(long),MSGTYPE_VICTORY,IPC_NOWAIT)!=-1);
    strncpy(victory,msg.victory,VICTORY_TXT_SIZE);
    if (strlen(victory)<3) strcpy(victory,"one player pressed the quit button!");
    
    sprintf(name,"bin/showVictory \"%s\" -display %s &",victory,di1.text().data());
/*killme*/							//di1.text() durch di1.text().data() ersetzt
    if (system(name)!=0) { cerr<<"cant execute "<<name<<endl; exit(1); }
    if (strcmp(di1.text().data(),di2.text().data())!=0) {
      sprintf(name,"bin/showVictory \"%s\" -display %s &",victory,di2.text().data());
/*killme*/							//di2.text() durch di2.text().data ersetzt
      if (system(name)!=0) { cerr<<"cant execute "<<name<<endl; exit(1); }
    }
    
    if (msgctl(msq_id,IPC_RMID,0)==-1) { perror("cant remove message queue"); exit(1); }
    msq_id=msgget(ipc_key,IPC_CREAT|0660);
    if (msq_id==-1) { perror("cant create msg-queue"); exit(1); }
    show();
    killTimers();
  }
  
}

void menu::readLevList() {
  
  ifstream	in("levels.lst");
  if (!in) { cerr<<"cant open levels.lst\n"; exit(1); }
  char		l[512];
  
  while (!in.eof()) {
    in>>l;
    if (strlen(l)>2) lev_list.inSort(l);
  }
  
}

void menu::showLevList() {
  
  lev_list.show();
  
}


void menu::levSelected(int index)//const char *l)
{
  lev_list.hide();
  lev.setText(lev_list.text(index));
//  lev.setText(l);
}

