
#ifndef menu_H
#define menu_H

#include <qwidget.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qlineedit.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <qlistbox.h>

#include "mytogglebutton.hh"

#define MSGTYPE_PID		1
#define MSGTYPE_VICTORY		2

#define VICTORY_TXT_SIZE	64

extern int msq_id;

typedef struct {
  long		mtype;
  pid_t		pid;
  char		victory[VICTORY_TXT_SIZE];
} MenuMsg;

class menu : public QWidget {
  
  Q_OBJECT
  
  public:
  
  menu();
  ~menu();
  
  protected:
  
  void timerEvent(QTimerEvent *);
  
  private slots:
  
  void start_battle();
  void levSelected(int);//const char *l);
  void showLevList();
  
  private:
  
  QPushButton		st_bat, choose_lev, quit_bt;
  MyToggleButton	sp1, sp2, ka1, ka2;
  QLineEdit		di1, di2, lev;
  QPixmap		title;
  pid_t			battle1, battle2, fight1, fight2;
  char			victory[VICTORY_TXT_SIZE];
  key_t			ipc_key;
  QListBox		lev_list;
  
  void readLevList();
  
};

#endif
